# user.js | Fennec F-Droid

I made this project to create something dedicated for Firefox for Android.
The `user.js` file is used to configure Firefox in the safest and fastest way possible.
To realize this project I was inspirated by various authors of `user.js` and I've implemented some preferences of mine.



## Aims:

* online security
* more privacy
* better performance
* less unique fingerprint possible



## Best Use:

This `user.js` has been designed for Mobile use and you can use on these browsers:

* [Fennec F-Droid](https://f-droid.org/en/packages/org.mozilla.fennec_fdroid/) - F-Droid
* [Firefox for Android](https://play.google.com/store/apps/details?id=org.mozilla.firefox&hl=en_US) - Google Play
* [IceCatMobile](https://f-droid.org/en/packages/org.mozilla.fennec_fdroid/) - F-Droid


## Settings Protection:

This file contains prefs. that are not native to the Android version of Firefox, but I have chosen to add them to avoid that in the future they can be implemented by Mozilla without we can realize it.
All this does not lead into stability issues.



## Installation:

### first root method (Fennec F-Droid)

- I would like to suggest you to use one of these file managers before proceed: [Amaze](https://f-droid.org/en/packages/com.amaze.filemanager/), [Dir](https://f-droid.org/en/packages/com.veniosg.dir) or [Ghost Commander](https://f-droid.org/en/packages/com.ghostsq.commander)
- Download and install Fennec F-Droid form the official [F-Droid client](https://f-droid.org/FDroid.apk) or from the official [F-Droid Website](https://f-droid.org/en/packages/org.mozilla.fennec_fdroid/)
- Start for the first time (offline mode/no data connections) and wait 5 sec.
- Close your browser
- Clone or download zip file and extract it
- Locate Fennec's installation directory `data/data/org.mozilla.fennec_fdroid/files/mozilla/[xxxxxxx].default`
- Copy the extracted `user.js` file to the install directory
- Delete `prefs.js` file inside the install directory
- Start Fennec F-Droid and test if `user.js` was applied browsing to `about:config` and look if `user.js.applied` is `true`.

If this doesn't work I suggest you to use "second root method" below.

### second root method (Fennec F-Droid)

- Download and install Fennec F-Droid form the official [F-Droid client](https://f-droid.org/FDroid.apk) or from the official [F-Droid Website](https://f-droid.org/en/packages/org.mozilla.fennec_fdroid/)
- Download and install [user.js-updater app](https://github.com/v1nc/user.js-updater/releases)
- Start for the first time (offline mode/no data connections) and wait 5 sec.
- Close your browser
- Open `user.js-updater` app
- Select the browser you want to apply `user.js` through the `SELECT BROWSER` bar at the top
- Select `quindecim` as the author
- Tap `UPDATE` at the bottom and grant root permission to proceed
- Start Fennec F-Droid and test if `user.js` was applied browsing to `about:config` and look if `user.js.applied` is `true`.

Thanks to [v1nc](https://github.com/v1nc/) for creating this app, useful for this method.



## Comparision:

You can also compare my `user.js` with `user.js` to other authors [HERE](https://quindecim.github.io/compare-user.js/)



## Contacts:

You can enjoy my [Telegram group](https://t.me/fennec_fdroid) for support or talk about privacy and security topics.



## Thanks:

I really thanks all the authors of `user.js` which inspired me:

* [gHacks](https://github.com/ghacksuserjs/ghacks-user.js)
* [Librefox Browser](https://github.com/intika/Librefox)
* [pyllyukko](https://github.com/pyllyukko/user.js)
* [OrangeManBad](https://git.nixnet.xyz/OrangeManBad/user.js) - (pyllyukko fork)
* [CHEF-KOCH](https://github.com/CHEF-KOCH/FFCK/tree/master/user.js)


## Special Thanks:

to all the members of my Telegram group who support me and give me motivation
